<?	
	@header('Content-type: text/html; charset=ISO-8859-1');
	/*---------------------------------------------------------------------*/
	/*																	
	/*						PHP CHINESE SEGMENTER	 		 		
	/*             			www.chine-informations.com    		
	/* 																	
	/* 												By David HOUSTIN, 2007
	/*---------------------------------------------------------------------*/
	
	
	function cn_segmenter ($text, $separateur=" ", $annotation=0) 
	{
			// ponctuation
			$chars_ponctuation = array ('&#12290;', '&#65292;', '&#65306;', '&#12289;', '&#65288;', '&#65289;', '&#12298;', '&#12299;', '&#12304;', '&#12305;', '&quot', '&#65311;','', '', '', ' ');
			
			include 'dictionnaire_segmenter.inc.php';
			
			// variables
			$nb_elmt_car 		= 8;	// nombre d'elements qui composent un caractre (ex : "&#20332;" = 8)
			$groupe_caracteres 	= 5;	// nombre de caractres max dans un groupe
			$num_ensemble 		= 1;
			
			// mise en forme 
			$text = html_entity_decode(stripslashes(trim($text)));
			$text = str_replace("; &#", ";&#", $text); // enlve les espaces entre caractres
		
			// tant qu'on est pas arriv  la fin du texte
			while (strlen($text) >= 1)
			{
				$char_find = 0;
				
				/*-----------------------------------------------------------------------------
				   On commence a chercher vec un maximum de caractre,
				   et on enlve un caractree  chaque fois si on ne trouve pas dans le dico
				------------------------------------------------------------------------------*/
				
				for ($j=$groupe_caracteres; $j != 0; $j--)
				{
					// on rcupre les X premiers caractres ($groupe_caracteres)
					$mots = substr ($text, 0, $j * $nb_elmt_car);
					
					// on vrifie si le caractre est dans le tableau
					$isinarray = in_array($mots, $chars_ponctuation);
					
					// on vrifie dans le tableau de X caracres si le mot est prsent
					if ($list_char[$mots] != 0 || $isinarray)
					{
						$new_text .= $mots . $separateur;
						
						if ($annotation == 1 && !$isinarray) 
						{
							if (empty($lechar[$mots])) 
							{
								$lechar[$mots] = $num_ensemble;
								$new_text .= "<sub>" . $num_ensemble . "</sub> ";
								$num_ensemble ++;
							}
							else $new_text .= "<sub>" . $lechar[$mots] . "</sub> ";
						}
						$text = substr ($text, ($j * $nb_elmt_car));
						$char_find = 1;
						break;
					}
				}
				
				/*-----------------------------------------------------------------------------
				   Si on ne trouve pas du tout dans le dico, car pas present ou 1 seul caractere
				   on passe au caractre sivant
				------------------------------------------------------------------------------*/
				
				if ($char_find == 0) 
				{
					// on verifie si c un caractre chinois ou autre (lettre ou chiffre)
					if (substr($text, 0, 2) == "&#") 
					{
						// caractre chinois
						$char_tmp = substr ($text, 0, $nb_elmt_car);
						if (substr($char_tmp, -1) == "&")  $nb_elmt_car_tmp = ($nb_elmt_car -1);
						else $nb_elmt_car_tmp = $nb_elmt_car;

						$char = substr ($text, 0, $nb_elmt_car_tmp);
						$isinarray = in_array($char, $chars_ponctuation);
						
						$new_text .=  $char . $separateur;
					
						if ($annotation == 1 && !$isinarray) 
						{
							if (empty($lechar[$char])) 
							{
								$new_text .= "<sub>" . $num_ensemble . "</sub> ";
								$lechar[$char] = $num_ensemble;
								$num_ensemble ++;
							}
							else $new_text .= "<sub>" . $lechar[$char] . "</sub> ";
						}
						$text = substr ($text, $nb_elmt_car_tmp); 
					}
					else 
					{
						// caractre alphanumrique
						$new_text .= substr ($text, 0, 1);
						$text = substr ($text, 1); 
					}
				}
			}
			$new_text = str_replace ("\n", "" . $separateur, $new_text);
			
			return $new_text;
	} 
	
?>